local importPath=string.gsub(getfenv(1)._.Name,"%.Stats","").."."
local resourcePath=string.gsub(importPath,"%.","/").."Resources/"
--todo
-- translations for Finesse, Base (resistance), Physical (mitigation)
-- what do we do for character="ALL"


loadData=function()
	charStats=PatchDataLoad( Turbine.DataScope.Server, "AltViewer_CharStats");
	if charStats==nil then
		-- attempt to import from alt_inventory
		local oldStats=PatchDataLoad( Turbine.DataScope.Server, "CharacterList");
		if oldStats~=nil then
			charStats={}
			for k,v in pairs(oldStats) do
				local TmpName=v[1];
				if string.sub(TmpName,1,1)~="&" and string.sub(TmpName,1,1)~="_" and v[2]~=nil and v[6]~=nil and v[5]~=nil and v[9]~=nil then
					if charList[TmpName]==nil then charList[TmpName]={} end
					if charList[TmpName].Level==nil then charList[TmpName].Level=v[2] end
					if charList[TmpName].Class==nil then charList[TmpName].Class=v[6] end
					if charList[TmpName].Race==nil then charList[TmpName].Race=v[5] end
					if charList[TmpName].Alignment==nil then charList[TmpName].Alignment=v[9] end
					charStats[TmpName]={["Morale"]=v[3],["Power"]=v[4],["AcidMitigation"]=v[12],["Agility"]=v[13],["Armor"]=v[14],["BaseAgility"]=v[15],["BaseCriticalHitAvoidance"]=v[16],["BaseCriticalHitChance"]=v[17],["BaseFate"]=v[18],["BaseMight"]=v[19],["BaseResistance"]=v[20],["BaseVitality"]=v[21],["BaseWill"]=v[22],["Block"]=v[23],["CommonMitigation"]=v[24],["DiseaseResistance"]=v[25],["Evade"]=v[26],["Fate"]=v[27],["FearResistance"]=v[28],["Finesse"]=v[29],["FireMitigation"]=v[30],["FrostMitigation"]=v[31],["IncomingHealing"]=v[32],["LightningMitigation"]=v[33],["MeleeCriticalHitAvoidance"]=v[34],["MeleeCriticalHitChance"]=v[35],["MeleeDamage"]=v[36],["MeleeDefence"]=v[37],["Might"]=v[38],["OutgoingHealing"]=v[39],["Parry"]=v[40],["PhysicalMitigation"]=v[41],["PoisonResistance"]=v[42],["RangeCriticalHitAvoidance"]=v[43],["RangeCriticalHitChance"]=v[44],["RangeDamage"]=v[45],["RangeDefence"]=v[46],["ShadowMitigation"]=v[47],["TacticalCriticalHitAvoidance"]=v[48],["TacticalCriticalHitChance"]=v[49],["TacticalDamage"]=v[50],["TacticalDefence"]=v[51],["TacticalMitigation"]=v[52],["Vitality"]=v[53],["Will"]=v[54],["WoundResistance"]=v[55]}

-- these stats may no longer be used
--["BaseAgility"]=v[15], ["BaseCriticalHitAvoidance"]=v[16], ["BaseCriticalHitChance"]=v[17], ["BaseFate"]=v[18], ["BaseMight"]=v[19], ["BaseVitality"]=v[21], ["BaseWill"]=v[22], ["DiseaseResistance"]=v[25],  ["FearResistance"]=v[28], ["MeleeDefence"]=v[37], ["PoisonResistance"]=v[42], ["RangeCriticalHitAvoidance"]=v[43], ["RangeCriticalHitChance"]=v[44], ["RangeDamage"]=v[45], ["RangeDefence"]=v[46], ["TacticalDefence"]=v[51], ["WoundResistance"]=v[55]}

				end
			end
		end
	end
	if charStats==nil then
		charStats={};
	end
	-- euronormalize all stats...
	for k,v in pairs(charStats) do
		for name,stat in pairs(v) do
			charStats[k][name]=euroNormalize(stat)
		end
	end
end
loadData()

classArray={{0,3,Resource[language][82]},{194,3,Resource[language][90]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][98]},{Turbine.Gameplay.Class.BlackArrow,2,Resource[language][93]},{Turbine.Gameplay.Class.Burglar,1,Resource[language][89]},{Turbine.Gameplay.Class.Captain,1,Resource[language][83]},{Turbine.Gameplay.Class.Champion,1,Resource[language][84]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][98]},{Turbine.Gameplay.Class.Defiler,2,Resource[language][97]},{Turbine.Gameplay.Class.Guardian,1,Resource[language][85]},{Turbine.Gameplay.Class.Hunter,1,Resource[language][87]},{Turbine.Gameplay.Class.LoreMaster,1,Resource[language][88]},{Turbine.Gameplay.Class.Minstrel,1,Resource[language][86]},{Turbine.Gameplay.Class.Ranger,1,Resource[language][100]},{Turbine.Gameplay.Class.Reaver,2,Resource[language][92]},{Turbine.Gameplay.Class.RuneKeeper,1,Resource[language][91]},{Turbine.Gameplay.Class.Stalker,2,Resource[language][95]},{Turbine.Gameplay.Class.WarLeader,2,Resource[language][94]},{Turbine.Gameplay.Class.Weaver,2,Resource[language][96]},{195,3,Resource[language][101]}};
raceArray={{0,Resource[language][82]},{Turbine.Gameplay.Race.Dwarf,Resource[language][72]},{Turbine.Gameplay.Race.Elf,Resource[language][74]},{Turbine.Gameplay.Race.Hobbit,Resource[language][73]},{Turbine.Gameplay.Race.Man,Resource[language][71]},{66,Resource[language][77]},{7,Resource[language][75]},{12,Resource[language][78]},{6,Resource[language][76]},{27,Resource[language][79]},{74,Resource[language][81]}}
function getClassIndex(turbineClass)
	local classIndex=1;
	for k,v in ipairs(classArray) do
		if v[1]==turbineClass then
			classIndex=k;
			break;
		end
	end
	return classIndex;
end
function getRaceIndex(turbineRace)
	local raceIndex=1;
	for k,v in ipairs(raceArray) do
		if v[1]==turbineRace then
			raceIndex=k;
			break;
		end
	end
	return raceIndex;
end

StatsPanel=Turbine.UI.Control()

StatsPanel:SetMouseVisible(false);
StatsPanel:SetVisible(false);
StatsPanel.NeedsRefresh=false
StatsPanel:SetWantsUpdates(false);
StatsPanel:SetSize(200,200); -- setting a default size prevents child controls initializing at a negative size which is VERY bad for text positioning
StatsPanel.VP=Turbine.UI.Control()
StatsPanel.VP:SetParent(StatsPanel);
StatsPanel.VP:SetBackColor(Turbine.UI.Color(1,0,0,0));
StatsPanel.VP:SetPosition(0,45);
StatsPanel.VP:SetSize(188,155);

StatsPanel.AP=Turbine.UI.Control();
StatsPanel.AP:SetParent(StatsPanel.VP);
StatsPanel.AP:SetBackColor(Turbine.UI.Color(1,0,0,0));
StatsPanel.AP:SetPosition(0,0);
StatsPanel.AP:SetSize(188,320);
StatsPanel.AP:SetZOrder(1);
StatsPanel.AP:SetVisible(true);

StatsPanel.VScroll=Turbine.UI.Lotro.ScrollBar();
StatsPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
StatsPanel.VScroll:SetParent(StatsPanel);
StatsPanel.VScroll:SetBackColor(backColor);
StatsPanel.VScroll:SetPosition(StatsPanel:GetWidth()-12,45);
StatsPanel.VScroll:SetWidth(12);
StatsPanel.VScroll:SetHeight(200);
StatsPanel.VScroll.ValueChanged=function()
	StatsPanel.AP:SetTop(0-StatsPanel.VScroll:GetValue())
end

StatsPanel.BogusAttributes={}
StatsPanel.BogusAttributes.GetArmor=function() return 0 end;
StatsPanel.BogusAttributes.GetAcidMitigation=function() return 0 end;
StatsPanel.BogusAttributes.GetAgility=function() return 0 end;
StatsPanel.BogusAttributes.GetFate=function() return 0 end;
StatsPanel.BogusAttributes.GetBaseResistance=function() return 0 end;
StatsPanel.BogusAttributes.GetBlock=function() return 0 end;
StatsPanel.BogusAttributes.GetCommonMitigation=function() return 0 end;
StatsPanel.BogusAttributes.GetDiseaseResistance=function() return 0 end;
StatsPanel.BogusAttributes.GetEvade=function() return 0 end;
StatsPanel.BogusAttributes.GetFearResistance=function() return 0 end;
StatsPanel.BogusAttributes.GetFinesse=function() return 0 end;
StatsPanel.BogusAttributes.GetFireMitigation=function() return 0 end;
StatsPanel.BogusAttributes.GetFrostMitigation=function() return 0 end;
StatsPanel.BogusAttributes.GetIncomingHealing=function() return 0 end;
StatsPanel.BogusAttributes.GetLightningMitigation=function() return 0 end;
StatsPanel.BogusAttributes.GetParry=function() return 0 end;
StatsPanel.BogusAttributes.GetPhysicalMitigation=function() return 0 end;
StatsPanel.BogusAttributes.GetPoisonResistance=function() return 0 end;
StatsPanel.BogusAttributes.GetShadowMitigation=function() return 0 end;
StatsPanel.BogusAttributes.GetTacticalMitigation=function() return 0 end;
StatsPanel.BogusAttributes.GetWoundResistance=function() return 0 end;
StatsPanel.BogusAttributes.GetOutgoingHealing=function() return 0 end;
StatsPanel.BogusAttributes.GetMight=function() return 0 end;
StatsPanel.BogusAttributes.GetVitality=function() return 0 end;
StatsPanel.BogusAttributes.GetWill=function() return 0 end;
StatsPanel.BogusAttributes.GetBaseCriticalHitAvoidance=function() return 0 end;
StatsPanel.BogusAttributes.GetMeleeCriticalHitAvoidance=function() return 0 end;
StatsPanel.BogusAttributes.GetRangeCriticalHitAvoidance=function() return 0 end;
StatsPanel.BogusAttributes.GetTacticalCriticalHitAvoidance=function() return 0 end;
StatsPanel.BogusAttributes.GetBaseCriticalHitChance=function() return 0 end;
StatsPanel.BogusAttributes.GetMeleeCriticalHitChance=function() return 0 end;
StatsPanel.BogusAttributes.GetRangeCriticalHitChance=function() return 0 end;
StatsPanel.BogusAttributes.GetTacticalCriticalHitChance=function() return 0 end;
StatsPanel.BogusAttributes.GetMeleeDamage=function() return 0 end;
StatsPanel.BogusAttributes.GetRangeDamage=function() return 0 end;
StatsPanel.BogusAttributes.GetTacticalDamage=function() return 0 end;
StatsPanel.BogusAttributes.GetMeleeDefence=function() return 0 end;
StatsPanel.BogusAttributes.GetRangeDefence=function() return 0 end;
StatsPanel.BogusAttributes.GetTacticalDefence=function() return 0 end;

if localPlayer:GetAlignment()==1 then
	StatsPanel.Attributes=localPlayer:GetAttributes();
else
	StatsPanel.Attributes=StatsPanel.BogusAttributes;
end

-- these three use resource strings in their displays so we need to track them for SetLanguage
StatsPanel.Race=getRaceIndex(localPlayer:GetRace());
StatsPanel.Class=getClassIndex(localPlayer:GetClass());
StatsPanel.Level=localPlayer:GetLevel();

local colWidth1=StatsPanel:GetWidth()/3;
local colWidth2=StatsPanel:GetWidth()/4;

StatsPanel.RaceBackground=Turbine.UI.Control();
StatsPanel.RaceBackground:SetParent(StatsPanel);
StatsPanel.RaceBackground:SetBlendMode(5);
StatsPanel.RaceBackground:SetSize(colWidth2,26);
StatsPanel.RaceBackground:SetPosition(0,0);
StatsPanel.RaceBackground:SetBackground(0x410dcf9f);
StatsPanel.RaceText=Turbine.UI.Label();
StatsPanel.RaceText:SetParent(StatsPanel.RaceBackground);
StatsPanel.RaceText:SetSize(colWidth2-5,18);
StatsPanel.RaceText:SetPosition(5,3);
StatsPanel.RaceText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.RaceText:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.RaceText:SetForeColor(fontColor);
StatsPanel.RaceText:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.RaceText:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.Separator1=Turbine.UI.Control();
StatsPanel.Separator1:SetParent(StatsPanel);
StatsPanel.Separator1:SetBlendMode(5);
StatsPanel.Separator1:SetSize(2,26);
StatsPanel.Separator1:SetPosition(colWidth2,0);
StatsPanel.Separator1:SetBackground(0x410dcfa0);
StatsPanel.GenderBackground=Turbine.UI.Control();
StatsPanel.GenderBackground:SetParent(StatsPanel);
StatsPanel.GenderBackground:SetBlendMode(5);
StatsPanel.GenderBackground:SetSize(colWidth2,26);
StatsPanel.GenderBackground:SetPosition(colWidth2+2,0);
StatsPanel.GenderBackground:SetBackground(0x410dcf9f);
StatsPanel.GenderText=Turbine.UI.Label();
StatsPanel.GenderText:SetParent(StatsPanel.GenderBackground);
StatsPanel.GenderText:SetSize(colWidth2-5,18);
StatsPanel.GenderText:SetPosition(5,3);
StatsPanel.GenderText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.GenderText:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.GenderText:SetForeColor(fontColor);
StatsPanel.GenderText:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.GenderText:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.GenderText:SetVisible(false); -- we use manual radio buttons until Turbine exposes gender via the API
StatsPanel.GenderRB=RadioButtonGroup();
StatsPanel.GenderRB:SetParent(StatsPanel.GenderBackground)
StatsPanel.GenderRB:SetSize(colWidth2-5,18);
StatsPanel.GenderRB:SetPosition(5,3);
StatsPanel.GenderRB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.GenderRB.UnselectedIcon=resourcePath.."RB_unselected.tga";
StatsPanel.GenderRB.SelectedIcon=resourcePath.."RB_selected.tga";
StatsPanel.GenderRB.IconWidth=16;
StatsPanel.GenderRB.IconHeight=16;
StatsPanel.GenderRB:SetBorderColor(0,0,0,0);
StatsPanel.GenderRB:SetBackColor(0,0,0,0);
StatsPanel.GenderRB:SetTextColor(settings.ForeColor);
StatsPanel.GenderRB:AddChoice("M","M");
StatsPanel.GenderRB:AddChoice("F","F");
StatsPanel.GenderRB:SetRows(1);
if charList[selectedCharName].Gender=="F" then
	StatsPanel.GenderRB:SetSelectedChoice(2);
else
	StatsPanel.GenderRB:SetSelectedChoice(1);
end
StatsPanel.LoadingData=false;
StatsPanel.GenderRB.SelectionChanged=function()
	if not StatsPanel.LoadingData then
		charList[selectedCharName].Gender=StatsPanel.GenderRB:GetValue();
		mainWindow:SetLanguage(); -- this will cause all panels with gender specific labels to be updated...
	end
end

StatsPanel.Separator5=Turbine.UI.Control();
StatsPanel.Separator5:SetParent(StatsPanel);
StatsPanel.Separator5:SetBlendMode(5);
StatsPanel.Separator5:SetSize(2,26);
StatsPanel.Separator5:SetPosition(colWidth2*2,0);
StatsPanel.Separator5:SetBackground(0x410dcfa0);
StatsPanel.ClassBackground=Turbine.UI.Control();
StatsPanel.ClassBackground:SetParent(StatsPanel);
StatsPanel.ClassBackground:SetBlendMode(5);
StatsPanel.ClassBackground:SetSize(colWidth2,26);
StatsPanel.ClassBackground:SetPosition(colWidth2*2+2,0);
StatsPanel.ClassBackground:SetBackground(0x410dcf9f);
StatsPanel.ClassText=Turbine.UI.Label();
StatsPanel.ClassText:SetParent(StatsPanel.ClassBackground);
StatsPanel.ClassText:SetSize(colWidth2-5,18);
StatsPanel.ClassText:SetPosition(5,3);
StatsPanel.ClassText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.ClassText:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.ClassText:SetForeColor(fontColor);
StatsPanel.ClassText:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.ClassText:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.Separator2=Turbine.UI.Control();
StatsPanel.Separator2:SetParent(StatsPanel);
StatsPanel.Separator2:SetBlendMode(5);
StatsPanel.Separator2:SetSize(2,26);
StatsPanel.Separator2:SetPosition(colWidth2*3,0);
StatsPanel.Separator2:SetBackground(0x410dcfa0);
StatsPanel.LevelBackground=Turbine.UI.Control();
StatsPanel.LevelBackground:SetParent(StatsPanel);
StatsPanel.LevelBackground:SetBlendMode(5);
StatsPanel.LevelBackground:SetSize(colWidth2,26);
StatsPanel.LevelBackground:SetPosition(colWidth2*3+2,0);
StatsPanel.LevelBackground:SetBackground(0x410dcf9f);
StatsPanel.LevelText=Turbine.UI.Label();
StatsPanel.LevelText:SetParent(StatsPanel.LevelBackground);
StatsPanel.LevelText:SetSize(colWidth2-5,18);
StatsPanel.LevelText:SetPosition(5,3);
StatsPanel.LevelText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.LevelText:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.LevelText:SetForeColor(fontColor);
StatsPanel.LevelText:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.LevelText:SetFontStyle(Turbine.UI.FontStyle.Outline);

StatsPanel.MoraleBackground=Turbine.UI.Control();
StatsPanel.MoraleBackground:SetParent(StatsPanel);
StatsPanel.MoraleBackground:SetBlendMode(5);
StatsPanel.MoraleBackground:SetSize(colWidth1,18);
StatsPanel.MoraleBackground:SetPosition(0,27);
StatsPanel.MoraleBackground:SetBackground(0x410dcf9f);
StatsPanel.MoraleIcon=Turbine.UI.Control();
StatsPanel.MoraleIcon:SetParent(StatsPanel.MoraleBackground);
StatsPanel.MoraleIcon:SetBlendMode(5);
StatsPanel.MoraleIcon:SetSize(24,25);
StatsPanel.MoraleIcon:SetPosition(3,-1);
StatsPanel.MoraleIcon:SetBackground(0x410dcfce);
StatsPanel.MoraleLabel=Turbine.UI.Label();
StatsPanel.MoraleLabel:SetParent(StatsPanel.MoraleBackground);
StatsPanel.MoraleLabel:SetSize(60,18);
StatsPanel.MoraleLabel:SetPosition(27,1);
StatsPanel.MoraleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.MoraleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.MoraleLabel:SetForeColor(Turbine.UI.Color(.33,.66,.33));
StatsPanel.MoraleLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.MoraleLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.MoraleValue=Turbine.UI.Label();
StatsPanel.MoraleValue:SetParent(StatsPanel.MoraleBackground);
StatsPanel.MoraleValue:SetSize(0,18);
StatsPanel.MoraleValue:SetPosition(88,1);
StatsPanel.MoraleValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.MoraleValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.MoraleValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.MoraleValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.MoraleValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.MoraleValue:SetText("0/0");
StatsPanel.Separator3=Turbine.UI.Control();
StatsPanel.Separator3:SetParent(StatsPanel);
StatsPanel.Separator3:SetBlendMode(5);
StatsPanel.Separator3:SetSize(2,18);
StatsPanel.Separator3:SetPosition(colWidth1,27);
StatsPanel.Separator3:SetBackground(0x410dcfa0);
StatsPanel.PowerBackground=Turbine.UI.Control();
StatsPanel.PowerBackground:SetParent(StatsPanel);
StatsPanel.PowerBackground:SetBlendMode(5);
StatsPanel.PowerBackground:SetSize(colWidth1,18);
StatsPanel.PowerBackground:SetPosition(colWidth1+2,27);
StatsPanel.PowerBackground:SetBackground(0x410dcf9f);
StatsPanel.PowerIcon=Turbine.UI.Control();
StatsPanel.PowerIcon:SetParent(StatsPanel.PowerBackground);
StatsPanel.PowerIcon:SetBlendMode(5);
StatsPanel.PowerIcon:SetSize(24,25);
StatsPanel.PowerIcon:SetPosition(3,-1);
StatsPanel.PowerIcon:SetBackground(0x410dcfcf);
StatsPanel.PowerLabel=Turbine.UI.Label();
StatsPanel.PowerLabel:SetParent(StatsPanel.PowerBackground);
StatsPanel.PowerLabel:SetSize(60,18);
StatsPanel.PowerLabel:SetPosition(27,1);
StatsPanel.PowerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.PowerLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.PowerLabel:SetForeColor(Turbine.UI.Color(0,.66,.75));
StatsPanel.PowerLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.PowerLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.PowerValue=Turbine.UI.Label();
StatsPanel.PowerValue:SetParent(StatsPanel.PowerBackground);
StatsPanel.PowerValue:SetSize(0,18);
StatsPanel.PowerValue:SetPosition(78,1);
StatsPanel.PowerValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.PowerValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.PowerValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.PowerValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.PowerValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.PowerValue:SetText("0/0");
StatsPanel.Separator4=Turbine.UI.Control();
StatsPanel.Separator4:SetParent(StatsPanel);
StatsPanel.Separator4:SetBlendMode(5);
StatsPanel.Separator4:SetSize(2,18);
StatsPanel.Separator4:SetPosition(colWidth1*2,27);
StatsPanel.Separator4:SetBackground(0x410dcfa0);
StatsPanel.ArmorBackground=Turbine.UI.Control();
StatsPanel.ArmorBackground:SetParent(StatsPanel);
StatsPanel.ArmorBackground:SetBlendMode(5);
StatsPanel.ArmorBackground:SetSize(colWidth1,18);
StatsPanel.ArmorBackground:SetPosition(colWidth1*2+2,27);
StatsPanel.ArmorBackground:SetBackground(0x410dcf9f);
StatsPanel.ArmorIcon=Turbine.UI.Control();
StatsPanel.ArmorIcon:SetParent(StatsPanel.ArmorBackground);
StatsPanel.ArmorIcon:SetBlendMode(5);
StatsPanel.ArmorIcon:SetSize(24,25);
StatsPanel.ArmorIcon:SetPosition(3,-1);
StatsPanel.ArmorIcon:SetBackground(0x410dcfd0);
StatsPanel.ArmorLabel=Turbine.UI.Label();
StatsPanel.ArmorLabel:SetParent(StatsPanel.ArmorBackground);
StatsPanel.ArmorLabel:SetSize(60,18);
StatsPanel.ArmorLabel:SetPosition(27,1);
StatsPanel.ArmorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.ArmorLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.ArmorLabel:SetForeColor(Turbine.UI.Color(.5,.4,.2));
StatsPanel.ArmorLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.ArmorLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.ArmorValue=Turbine.UI.Label();
StatsPanel.ArmorValue:SetParent(StatsPanel.ArmorBackground);
StatsPanel.ArmorValue:SetSize(0,18);
StatsPanel.ArmorValue:SetPosition(88,1);
StatsPanel.ArmorValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.ArmorValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.ArmorValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.ArmorValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.ArmorValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.ArmorValue:SetText("0");

colWidth1=StatsPanel:GetWidth()/2;
colWidth2=StatsPanel:GetWidth()/2-102;
local colWidth3=StatsPanel:GetWidth()/2+102;

StatsPanel.StatsHeading=Turbine.UI.Label();
StatsPanel.StatsHeading:SetParent(StatsPanel.AP);
StatsPanel.StatsHeading:SetSize(colWidth1-10,18);
StatsPanel.StatsHeading:SetPosition(5,5);
StatsPanel.StatsHeading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.StatsHeading:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
StatsPanel.StatsHeading:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.StatsHeading:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.StatsHeading:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.StatsSeparator=Turbine.UI.Control();
StatsPanel.StatsSeparator:SetParent(StatsPanel.AP);
StatsPanel.StatsSeparator:SetSize(StatsPanel.StatsHeading:GetWidth(),1);
StatsPanel.StatsSeparator:SetPosition(StatsPanel.StatsHeading:GetLeft(),StatsPanel.StatsHeading:GetTop()+18);
StatsPanel.StatsSeparator:SetBackColor(settings.TrimColor);
StatsPanel.MightLabel=Turbine.UI.Label();
StatsPanel.MightLabel:SetParent(StatsPanel.AP);
StatsPanel.MightLabel:SetSize(100,15);
StatsPanel.MightLabel:SetPosition(5,StatsPanel.StatsHeading:GetTop()+20);
StatsPanel.MightLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.MightLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.MightLabel:SetForeColor(fontColor);
StatsPanel.MightLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.MightLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.MightValue=Turbine.UI.Label();
StatsPanel.MightValue:SetParent(StatsPanel.AP);
StatsPanel.MightValue:SetSize(colWidth2,15);
StatsPanel.MightValue:SetPosition(102,StatsPanel.MightLabel:GetTop());
StatsPanel.MightValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.MightValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.MightValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.MightValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.MightValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.MightValue:SetText(0);
StatsPanel.AgilityLabel=Turbine.UI.Label();
StatsPanel.AgilityLabel:SetParent(StatsPanel.AP);
StatsPanel.AgilityLabel:SetSize(100,15);
StatsPanel.AgilityLabel:SetPosition(5,StatsPanel.MightLabel:GetTop()+15);
StatsPanel.AgilityLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.AgilityLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.AgilityLabel:SetForeColor(fontColor);
StatsPanel.AgilityLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.AgilityLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.AgilityValue=Turbine.UI.Label();
StatsPanel.AgilityValue:SetParent(StatsPanel.AP);
StatsPanel.AgilityValue:SetSize(colWidth2,15);
StatsPanel.AgilityValue:SetPosition(102,StatsPanel.AgilityLabel:GetTop());
StatsPanel.AgilityValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.AgilityValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.AgilityValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.AgilityValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.AgilityValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.AgilityValue:SetText("0");
StatsPanel.VitalityLabel=Turbine.UI.Label();
StatsPanel.VitalityLabel:SetParent(StatsPanel.AP);
StatsPanel.VitalityLabel:SetSize(100,15);
StatsPanel.VitalityLabel:SetPosition(5,StatsPanel.AgilityLabel:GetTop()+15);
StatsPanel.VitalityLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.VitalityLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.VitalityLabel:SetForeColor(fontColor);
StatsPanel.VitalityLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.VitalityLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.VitalityValue=Turbine.UI.Label();
StatsPanel.VitalityValue:SetParent(StatsPanel.AP);
StatsPanel.VitalityValue:SetSize(colWidth2,15);
StatsPanel.VitalityValue:SetPosition(102,StatsPanel.VitalityLabel:GetTop());
StatsPanel.VitalityValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.VitalityValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.VitalityValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.VitalityValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.VitalityValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.VitalityValue:SetText(0);
StatsPanel.WillLabel=Turbine.UI.Label();
StatsPanel.WillLabel:SetParent(StatsPanel.AP);
StatsPanel.WillLabel:SetSize(100,15);
StatsPanel.WillLabel:SetPosition(5,StatsPanel.VitalityLabel:GetTop()+15);
StatsPanel.WillLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.WillLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.WillLabel:SetForeColor(fontColor);
StatsPanel.WillLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.WillLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.WillValue=Turbine.UI.Label();
StatsPanel.WillValue:SetParent(StatsPanel.AP);
StatsPanel.WillValue:SetSize(colWidth2,15);
StatsPanel.WillValue:SetPosition(102,StatsPanel.WillLabel:GetTop());
StatsPanel.WillValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.WillValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.WillValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.WillValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.WillValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.WillValue:SetText(0);
StatsPanel.FateLabel=Turbine.UI.Label();
StatsPanel.FateLabel:SetParent(StatsPanel.AP);
StatsPanel.FateLabel:SetSize(100,15);
StatsPanel.FateLabel:SetPosition(5,StatsPanel.WillLabel:GetTop()+15);
StatsPanel.FateLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.FateLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.FateLabel:SetForeColor(fontColor);
StatsPanel.FateLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.FateLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.FateValue=Turbine.UI.Label();
StatsPanel.FateValue:SetParent(StatsPanel.AP);
StatsPanel.FateValue:SetSize(colWidth2,15);
StatsPanel.FateValue:SetPosition(102,StatsPanel.FateLabel:GetTop());
StatsPanel.FateValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.FateValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.FateValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.FateValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.FateValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.FateValue:SetText(0);

StatsPanel.FinesseLabel=Turbine.UI.Label();
StatsPanel.FinesseLabel:SetParent(StatsPanel.AP);
StatsPanel.FinesseLabel:SetSize(100,15);
StatsPanel.FinesseLabel:SetPosition(5,StatsPanel.FateLabel:GetTop()+20);
StatsPanel.FinesseLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.FinesseLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.FinesseLabel:SetForeColor(fontColor);
StatsPanel.FinesseLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.FinesseLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.FinesseValue=Turbine.UI.Label();
StatsPanel.FinesseValue:SetParent(StatsPanel.AP);
StatsPanel.FinesseValue:SetSize(colWidth2,15);
StatsPanel.FinesseValue:SetPosition(102,StatsPanel.FinesseLabel:GetTop());
StatsPanel.FinesseValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.FinesseValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.FinesseValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.FinesseValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.FinesseValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.FinesseValue:SetText(0);

StatsPanel.HealingHeading=Turbine.UI.Label();
StatsPanel.HealingHeading:SetParent(StatsPanel.AP);
StatsPanel.HealingHeading:SetSize(colWidth1-10,18);
StatsPanel.HealingHeading:SetPosition(5,StatsPanel.FinesseLabel:GetTop()+20);
StatsPanel.HealingHeading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.HealingHeading:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
StatsPanel.HealingHeading:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.HealingHeading:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.HealingHeading:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.HealingSeparator=Turbine.UI.Control();
StatsPanel.HealingSeparator:SetParent(StatsPanel.AP);
StatsPanel.HealingSeparator:SetSize(StatsPanel.HealingHeading:GetWidth(),1);
StatsPanel.HealingSeparator:SetPosition(StatsPanel.HealingHeading:GetLeft(),StatsPanel.HealingHeading:GetTop()+18);
StatsPanel.HealingSeparator:SetBackColor(settings.TrimColor);
StatsPanel.OutgoingLabel=Turbine.UI.Label();
StatsPanel.OutgoingLabel:SetParent(StatsPanel.AP);
StatsPanel.OutgoingLabel:SetSize(100,15);
StatsPanel.OutgoingLabel:SetPosition(5,StatsPanel.HealingHeading:GetTop()+20);
StatsPanel.OutgoingLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.OutgoingLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.OutgoingLabel:SetForeColor(fontColor);
StatsPanel.OutgoingLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.OutgoingLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.OutgoingValue=Turbine.UI.Label();
StatsPanel.OutgoingValue:SetParent(StatsPanel.AP);
StatsPanel.OutgoingValue:SetSize(colWidth2,15);
StatsPanel.OutgoingValue:SetPosition(102,StatsPanel.OutgoingLabel:GetTop());
StatsPanel.OutgoingValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.OutgoingValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.OutgoingValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.OutgoingValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.OutgoingValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.OutgoingValue:SetText(0);
StatsPanel.IncomingLabel=Turbine.UI.Label();
StatsPanel.IncomingLabel:SetParent(StatsPanel.AP);
StatsPanel.IncomingLabel:SetSize(100,15);
StatsPanel.IncomingLabel:SetPosition(5,StatsPanel.OutgoingLabel:GetTop()+15);
StatsPanel.IncomingLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.IncomingLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.IncomingLabel:SetForeColor(fontColor);
StatsPanel.IncomingLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.IncomingLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.IncomingValue=Turbine.UI.Label();
StatsPanel.IncomingValue:SetParent(StatsPanel.AP);
StatsPanel.IncomingValue:SetSize(colWidth2,15);
StatsPanel.IncomingValue:SetPosition(102,StatsPanel.IncomingLabel:GetTop());
StatsPanel.IncomingValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.IncomingValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.IncomingValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.IncomingValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.IncomingValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.IncomingValue:SetText(0);

StatsPanel.AvoidancesHeading=Turbine.UI.Label();
StatsPanel.AvoidancesHeading:SetParent(StatsPanel.AP);
StatsPanel.AvoidancesHeading:SetSize(colWidth1-10,18);
StatsPanel.AvoidancesHeading:SetPosition(5,StatsPanel.IncomingLabel:GetTop()+20);
StatsPanel.AvoidancesHeading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.AvoidancesHeading:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
StatsPanel.AvoidancesHeading:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.AvoidancesHeading:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.AvoidancesHeading:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.AvoidancesSeparator=Turbine.UI.Control();
StatsPanel.AvoidancesSeparator:SetParent(StatsPanel.AP);
StatsPanel.AvoidancesSeparator:SetSize(StatsPanel.AvoidancesHeading:GetWidth(),1);
StatsPanel.AvoidancesSeparator:SetPosition(StatsPanel.AvoidancesHeading:GetLeft(),StatsPanel.AvoidancesHeading:GetTop()+18);
StatsPanel.AvoidancesSeparator:SetBackColor(settings.TrimColor);
StatsPanel.BlockLabel=Turbine.UI.Label();
StatsPanel.BlockLabel:SetParent(StatsPanel.AP);
StatsPanel.BlockLabel:SetSize(100,15);
StatsPanel.BlockLabel:SetPosition(5,StatsPanel.AvoidancesHeading:GetTop()+20);
StatsPanel.BlockLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.BlockLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.BlockLabel:SetForeColor(fontColor);
StatsPanel.BlockLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.BlockLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.BlockValue=Turbine.UI.Label();
StatsPanel.BlockValue:SetParent(StatsPanel.AP);
StatsPanel.BlockValue:SetSize(colWidth2,15);
StatsPanel.BlockValue:SetPosition(102,StatsPanel.BlockLabel:GetTop());
StatsPanel.BlockValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.BlockValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.BlockValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.BlockValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.BlockValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.BlockValue:SetText(0);
StatsPanel.ParryLabel=Turbine.UI.Label();
StatsPanel.ParryLabel:SetParent(StatsPanel.AP);
StatsPanel.ParryLabel:SetSize(100,15);
StatsPanel.ParryLabel:SetPosition(5,StatsPanel.BlockLabel:GetTop()+15);
StatsPanel.ParryLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.ParryLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.ParryLabel:SetForeColor(fontColor);
StatsPanel.ParryLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.ParryLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.ParryValue=Turbine.UI.Label();
StatsPanel.ParryValue:SetParent(StatsPanel.AP);
StatsPanel.ParryValue:SetSize(colWidth2,15);
StatsPanel.ParryValue:SetPosition(102,StatsPanel.ParryLabel:GetTop());
StatsPanel.ParryValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.ParryValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.ParryValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.ParryValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.ParryValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.ParryValue:SetText(0);
StatsPanel.EvadeLabel=Turbine.UI.Label();
StatsPanel.EvadeLabel:SetParent(StatsPanel.AP);
StatsPanel.EvadeLabel:SetSize(100,15);
StatsPanel.EvadeLabel:SetPosition(5,StatsPanel.ParryLabel:GetTop()+15);
StatsPanel.EvadeLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.EvadeLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.EvadeLabel:SetForeColor(fontColor);
StatsPanel.EvadeLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.EvadeLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.EvadeValue=Turbine.UI.Label();
StatsPanel.EvadeValue:SetParent(StatsPanel.AP);
StatsPanel.EvadeValue:SetSize(colWidth2,15);
StatsPanel.EvadeValue:SetPosition(102,StatsPanel.EvadeLabel:GetTop());
StatsPanel.EvadeValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.EvadeValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.EvadeValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.EvadeValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.EvadeValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.EvadeValue:SetText(0);

StatsPanel.ResistancesHeading=Turbine.UI.Label();
StatsPanel.ResistancesHeading:SetParent(StatsPanel.AP);
StatsPanel.ResistancesHeading:SetSize(colWidth1-10,18);
StatsPanel.ResistancesHeading:SetPosition(colWidth1,5);
StatsPanel.ResistancesHeading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.ResistancesHeading:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
StatsPanel.ResistancesHeading:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.ResistancesHeading:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.ResistancesHeading:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.ResistancesSeparator=Turbine.UI.Control();
StatsPanel.ResistancesSeparator:SetParent(StatsPanel.AP);
StatsPanel.ResistancesSeparator:SetSize(StatsPanel.ResistancesHeading:GetWidth(),1);
StatsPanel.ResistancesSeparator:SetPosition(StatsPanel.ResistancesHeading:GetLeft(),StatsPanel.ResistancesHeading:GetTop()+18);
StatsPanel.ResistancesSeparator:SetBackColor(settings.TrimColor);
StatsPanel.BaseLabel=Turbine.UI.Label();
StatsPanel.BaseLabel:SetParent(StatsPanel.AP);
StatsPanel.BaseLabel:SetSize(100,15);
StatsPanel.BaseLabel:SetPosition(colWidth1,StatsPanel.ResistancesHeading:GetTop()+20);
StatsPanel.BaseLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.BaseLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.BaseLabel:SetForeColor(fontColor);
StatsPanel.BaseLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.BaseLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.BaseValue=Turbine.UI.Label();
StatsPanel.BaseValue:SetParent(StatsPanel.AP);
StatsPanel.BaseValue:SetSize(colWidth2,15);
StatsPanel.BaseValue:SetPosition(102,StatsPanel.BaseLabel:GetTop());
StatsPanel.BaseValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.BaseValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.BaseValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.BaseValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.BaseValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.BaseValue:SetText("0");

StatsPanel.MitigationsHeading=Turbine.UI.Label();
StatsPanel.MitigationsHeading:SetParent(StatsPanel.AP);
StatsPanel.MitigationsHeading:SetSize(colWidth1-10,18);
StatsPanel.MitigationsHeading:SetPosition(colWidth1,StatsPanel.BaseLabel:GetTop()+20);
StatsPanel.MitigationsHeading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.MitigationsHeading:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
StatsPanel.MitigationsHeading:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.MitigationsHeading:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.MitigationsHeading:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.MitigationsSeparator=Turbine.UI.Control();
StatsPanel.MitigationsSeparator:SetParent(StatsPanel.AP);
StatsPanel.MitigationsSeparator:SetSize(StatsPanel.MitigationsHeading:GetWidth(),1);
StatsPanel.MitigationsSeparator:SetPosition(StatsPanel.MitigationsHeading:GetLeft(),StatsPanel.MitigationsHeading:GetTop()+18);
StatsPanel.MitigationsSeparator:SetBackColor(settings.TrimColor);
StatsPanel.CommonLabel=Turbine.UI.Label();
StatsPanel.CommonLabel:SetParent(StatsPanel.AP);
StatsPanel.CommonLabel:SetSize(100,15);
StatsPanel.CommonLabel:SetPosition(colWidth1,StatsPanel.MitigationsHeading:GetTop()+20);
StatsPanel.CommonLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.CommonLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.CommonLabel:SetForeColor(fontColor);
StatsPanel.CommonLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.CommonLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.CommonValue=Turbine.UI.Label();
StatsPanel.CommonValue:SetParent(StatsPanel.AP);
StatsPanel.CommonValue:SetSize(colWidth2,15);
StatsPanel.CommonValue:SetPosition(colWidth3,StatsPanel.CommonLabel:GetTop());
StatsPanel.CommonValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.CommonValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.CommonValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.CommonValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.CommonValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.CommonValue:SetText(0);
StatsPanel.FireLabel=Turbine.UI.Label();
StatsPanel.FireLabel:SetParent(StatsPanel.AP);
StatsPanel.FireLabel:SetSize(100,15);
StatsPanel.FireLabel:SetPosition(colWidth1,StatsPanel.CommonLabel:GetTop()+15);
StatsPanel.FireLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.FireLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.FireLabel:SetForeColor(fontColor);
StatsPanel.FireLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.FireLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.FireValue=Turbine.UI.Label();
StatsPanel.FireValue:SetParent(StatsPanel.AP);
StatsPanel.FireValue:SetSize(colWidth2,15);
StatsPanel.FireValue:SetPosition(colWidth3,StatsPanel.FireLabel:GetTop());
StatsPanel.FireValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.FireValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.FireValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.FireValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.FireValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.FireValue:SetText(0);
StatsPanel.FrostLabel=Turbine.UI.Label();
StatsPanel.FrostLabel:SetParent(StatsPanel.AP);
StatsPanel.FrostLabel:SetSize(100,15);
StatsPanel.FrostLabel:SetPosition(colWidth1,StatsPanel.FireLabel:GetTop()+15);
StatsPanel.FrostLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.FrostLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.FrostLabel:SetForeColor(fontColor);
StatsPanel.FrostLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.FrostLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.FrostValue=Turbine.UI.Label();
StatsPanel.FrostValue:SetParent(StatsPanel.AP);
StatsPanel.FrostValue:SetSize(colWidth2,15);
StatsPanel.FrostValue:SetPosition(colWidth3,StatsPanel.FrostLabel:GetTop());
StatsPanel.FrostValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.FrostValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.FrostValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.FrostValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.FrostValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.FrostValue:SetText(0);
StatsPanel.ShadowLabel=Turbine.UI.Label();
StatsPanel.ShadowLabel:SetParent(StatsPanel.AP);
StatsPanel.ShadowLabel:SetSize(100,15);
StatsPanel.ShadowLabel:SetPosition(colWidth1,StatsPanel.FrostLabel:GetTop()+15);
StatsPanel.ShadowLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.ShadowLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.ShadowLabel:SetForeColor(fontColor);
StatsPanel.ShadowLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.ShadowLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.ShadowValue=Turbine.UI.Label();
StatsPanel.ShadowValue:SetParent(StatsPanel.AP);
StatsPanel.ShadowValue:SetSize(colWidth2,15);
StatsPanel.ShadowValue:SetPosition(colWidth3,StatsPanel.ShadowLabel:GetTop());
StatsPanel.ShadowValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.ShadowValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.ShadowValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.ShadowValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.ShadowValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.ShadowValue:SetText(0);
StatsPanel.LightningLabel=Turbine.UI.Label();
StatsPanel.LightningLabel:SetParent(StatsPanel.AP);
StatsPanel.LightningLabel:SetSize(100,15);
StatsPanel.LightningLabel:SetPosition(colWidth1,StatsPanel.ShadowLabel:GetTop()+15);
StatsPanel.LightningLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.LightningLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.LightningLabel:SetForeColor(fontColor);
StatsPanel.LightningLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.LightningLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.LightningValue=Turbine.UI.Label();
StatsPanel.LightningValue:SetParent(StatsPanel.AP);
StatsPanel.LightningValue:SetSize(colWidth2,15);
StatsPanel.LightningValue:SetPosition(colWidth3,StatsPanel.LightningLabel:GetTop());
StatsPanel.LightningValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.LightningValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.LightningValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.LightningValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.LightningValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.LightningValue:SetText(0);
StatsPanel.AcidLabel=Turbine.UI.Label();
StatsPanel.AcidLabel:SetParent(StatsPanel.AP);
StatsPanel.AcidLabel:SetSize(100,15);
StatsPanel.AcidLabel:SetPosition(colWidth1,StatsPanel.LightningLabel:GetTop()+15);
StatsPanel.AcidLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.AcidLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.AcidLabel:SetForeColor(fontColor);
StatsPanel.AcidLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.AcidLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.AcidValue=Turbine.UI.Label();
StatsPanel.AcidValue:SetParent(StatsPanel.AP);
StatsPanel.AcidValue:SetSize(colWidth2,15);
StatsPanel.AcidValue:SetPosition(colWidth3,StatsPanel.AcidLabel:GetTop());
StatsPanel.AcidValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.AcidValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.AcidValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.AcidValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.AcidValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.AcidValue:SetText("0");
StatsPanel.PhysicalLabel=Turbine.UI.Label();
StatsPanel.PhysicalLabel:SetParent(StatsPanel.AP);
StatsPanel.PhysicalLabel:SetSize(100,15);
StatsPanel.PhysicalLabel:SetPosition(colWidth1,StatsPanel.AcidLabel:GetTop()+15);
StatsPanel.PhysicalLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.PhysicalLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.PhysicalLabel:SetForeColor(fontColor);
StatsPanel.PhysicalLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.PhysicalLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.PhysicalValue=Turbine.UI.Label();
StatsPanel.PhysicalValue:SetParent(StatsPanel.AP);
StatsPanel.PhysicalValue:SetSize(colWidth2,15);
StatsPanel.PhysicalValue:SetPosition(colWidth3,StatsPanel.PhysicalLabel:GetTop());
StatsPanel.PhysicalValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.PhysicalValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.PhysicalValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.PhysicalValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.PhysicalValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.PhysicalValue:SetText(0);

StatsPanel.TacticalLabel=Turbine.UI.Label();
StatsPanel.TacticalLabel:SetParent(StatsPanel.AP);
StatsPanel.TacticalLabel:SetSize(100,15);
StatsPanel.TacticalLabel:SetPosition(colWidth1,StatsPanel.PhysicalLabel:GetTop()+15);
StatsPanel.TacticalLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.TacticalLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.TacticalLabel:SetForeColor(fontColor);
StatsPanel.TacticalLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.TacticalLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.TacticalValue=Turbine.UI.Label();
StatsPanel.TacticalValue:SetParent(StatsPanel.AP);
StatsPanel.TacticalValue:SetSize(colWidth2,15);
StatsPanel.TacticalValue:SetPosition(colWidth3,StatsPanel.TacticalLabel:GetTop());
StatsPanel.TacticalValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.TacticalValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.TacticalValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.TacticalValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.TacticalValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.TacticalValue:SetText(0);

-- create the table with Melee, Ranged, Tactical labels across the top and Criticals, Crit Def, Offence, Defence as values
colWidth1=StatsPanel:GetWidth()/3;

StatsPanel.MeleeHeading=Turbine.UI.Label();
StatsPanel.MeleeHeading:SetParent(StatsPanel.AP);
StatsPanel.MeleeHeading:SetSize(colWidth1,18);
StatsPanel.MeleeHeading:SetPosition(colWidth1,StatsPanel.EvadeLabel:GetTop()+20);
StatsPanel.MeleeHeading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.MeleeHeading:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
StatsPanel.MeleeHeading:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.MeleeHeading:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.MeleeHeading:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.MeleeSeparator=Turbine.UI.Control();
StatsPanel.MeleeSeparator:SetParent(StatsPanel.AP);
StatsPanel.MeleeSeparator:SetSize(StatsPanel.MeleeHeading:GetWidth(),1);
StatsPanel.MeleeSeparator:SetPosition(StatsPanel.MeleeHeading:GetLeft(),StatsPanel.MeleeHeading:GetTop()+18);
StatsPanel.MeleeSeparator:SetBackColor(settings.TrimColor);

StatsPanel.TacticalHeading=Turbine.UI.Label();
StatsPanel.TacticalHeading:SetParent(StatsPanel.AP);
StatsPanel.TacticalHeading:SetSize(colWidth1,18);
StatsPanel.TacticalHeading:SetPosition(colWidth1,StatsPanel.MeleeHeading:GetTop());
StatsPanel.TacticalHeading:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.TacticalHeading:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
StatsPanel.TacticalHeading:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.TacticalHeading:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.TacticalHeading:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.TacticalSeparator=Turbine.UI.Control();
StatsPanel.TacticalSeparator:SetParent(StatsPanel.AP);
StatsPanel.TacticalSeparator:SetSize(StatsPanel.TacticalHeading:GetWidth(),1);
StatsPanel.TacticalSeparator:SetPosition(StatsPanel.TacticalHeading:GetLeft(),StatsPanel.TacticalHeading:GetTop()+18);
StatsPanel.TacticalSeparator:SetBackColor(settings.TrimColor);

StatsPanel.CriticalAvoidLabel=Turbine.UI.Label();
StatsPanel.CriticalAvoidLabel:SetParent(StatsPanel.AP);
StatsPanel.CriticalAvoidLabel:SetSize(colWidth1-1,15);
StatsPanel.CriticalAvoidLabel:SetPosition(1,StatsPanel.MeleeHeading:GetTop()+20);
StatsPanel.CriticalAvoidLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.CriticalAvoidLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.CriticalAvoidLabel:SetForeColor(fontColor);
StatsPanel.CriticalAvoidLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.CriticalAvoidLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);

StatsPanel.CriticalMeleeAvoidValue=Turbine.UI.Label();
StatsPanel.CriticalMeleeAvoidValue:SetParent(StatsPanel.AP);
StatsPanel.CriticalMeleeAvoidValue:SetSize(colWidth1,15);
StatsPanel.CriticalMeleeAvoidValue:SetPosition(colWidth1,StatsPanel.CriticalAvoidLabel:GetTop());
StatsPanel.CriticalMeleeAvoidValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.CriticalMeleeAvoidValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.CriticalMeleeAvoidValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.CriticalMeleeAvoidValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.CriticalMeleeAvoidValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.CriticalMeleeAvoidValue:SetText(0);

StatsPanel.CriticalTacticalAvoidValue=Turbine.UI.Label();
StatsPanel.CriticalTacticalAvoidValue:SetParent(StatsPanel.AP);
StatsPanel.CriticalTacticalAvoidValue:SetSize(colWidth1,15);
StatsPanel.CriticalTacticalAvoidValue:SetPosition(colWidth1*2,StatsPanel.CriticalAvoidLabel:GetTop());
StatsPanel.CriticalTacticalAvoidValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.CriticalTacticalAvoidValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.CriticalTacticalAvoidValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.CriticalTacticalAvoidValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.CriticalTacticalAvoidValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.CriticalTacticalAvoidValue:SetText(0);

StatsPanel.CritHitChanceLabel=Turbine.UI.Label();
StatsPanel.CritHitChanceLabel:SetParent(StatsPanel.AP);
StatsPanel.CritHitChanceLabel:SetSize(colWidth1-1,15);
StatsPanel.CritHitChanceLabel:SetPosition(1,StatsPanel.CriticalAvoidLabel:GetTop()+15);
StatsPanel.CritHitChanceLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.CritHitChanceLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.CritHitChanceLabel:SetForeColor(fontColor);
StatsPanel.CritHitChanceLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.CritHitChanceLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);

StatsPanel.CritHitMeleeChanceValue=Turbine.UI.Label();
StatsPanel.CritHitMeleeChanceValue:SetParent(StatsPanel.AP);
StatsPanel.CritHitMeleeChanceValue:SetSize(colWidth1,15);
StatsPanel.CritHitMeleeChanceValue:SetPosition(colWidth1,StatsPanel.CritHitChanceLabel:GetTop());
StatsPanel.CritHitMeleeChanceValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.CritHitMeleeChanceValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.CritHitMeleeChanceValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.CritHitMeleeChanceValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.CritHitMeleeChanceValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.CritHitMeleeChanceValue:SetText(StatsPanel.CritDefMelee);

StatsPanel.CritHitTacticalChanceValue=Turbine.UI.Label();
StatsPanel.CritHitTacticalChanceValue:SetParent(StatsPanel.AP);
StatsPanel.CritHitTacticalChanceValue:SetSize(colWidth1,15);
StatsPanel.CritHitTacticalChanceValue:SetPosition(colWidth1*2,StatsPanel.CritHitChanceLabel:GetTop());
StatsPanel.CritHitTacticalChanceValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.CritHitTacticalChanceValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.CritHitTacticalChanceValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.CritHitTacticalChanceValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.CritHitTacticalChanceValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.CritHitTacticalChanceValue:SetText(0);

StatsPanel.DamageLabel=Turbine.UI.Label();
StatsPanel.DamageLabel:SetParent(StatsPanel.AP);
StatsPanel.DamageLabel:SetSize(colWidth1-1,15);
StatsPanel.DamageLabel:SetPosition(1,StatsPanel.CritHitChanceLabel:GetTop()+15);
StatsPanel.DamageLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
StatsPanel.DamageLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
StatsPanel.DamageLabel:SetForeColor(fontColor);
StatsPanel.DamageLabel:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.DamageLabel:SetFontStyle(Turbine.UI.FontStyle.Outline);

StatsPanel.DamageMeleeValue=Turbine.UI.Label();
StatsPanel.DamageMeleeValue:SetParent(StatsPanel.AP);
StatsPanel.DamageMeleeValue:SetSize(colWidth1,15);
StatsPanel.DamageMeleeValue:SetPosition(colWidth1*1,StatsPanel.DamageLabel:GetTop());
StatsPanel.DamageMeleeValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.DamageMeleeValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.DamageMeleeValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.DamageMeleeValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.DamageMeleeValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.DamageMeleeValue:SetText(0);

StatsPanel.DamageTacticalValue=Turbine.UI.Label();
StatsPanel.DamageTacticalValue:SetParent(StatsPanel.AP);
StatsPanel.DamageTacticalValue:SetSize(colWidth1,15);
StatsPanel.DamageTacticalValue:SetPosition(colWidth1*2,StatsPanel.DamageLabel:GetTop());
StatsPanel.DamageTacticalValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
StatsPanel.DamageTacticalValue:SetFont(Turbine.UI.Lotro.Font.Verdana12);
StatsPanel.DamageTacticalValue:SetForeColor(Turbine.UI.Color(1,1,1));
StatsPanel.DamageTacticalValue:SetOutlineColor(Turbine.UI.Color(0,0,0));
StatsPanel.DamageTacticalValue:SetFontStyle(Turbine.UI.FontStyle.Outline);
StatsPanel.DamageTacticalValue:SetText(0);

StatsPanel.SizeChanged=function(Sender,Args)
	local NewWidth,NewHeight=mainWindow.PanelBack:GetSize();
	Turbine.UI.Control.SetSize(StatsPanel,NewWidth,NewHeight);

	StatsPanel.VP:SetSize(NewWidth-12,NewHeight-45);
	StatsPanel.AP:SetWidth(NewWidth-12);
	StatsPanel.VScroll:SetHeight(NewHeight-45);
	StatsPanel.VScroll:SetLeft(NewWidth-12);
	if StatsPanel.AP:GetHeight()>StatsPanel.VP:GetHeight() then
		StatsPanel.VScroll:SetMaximum(StatsPanel.AP:GetHeight()-StatsPanel.VP:GetHeight());
		StatsPanel.VScroll:SetVisible(true);
	else
		StatsPanel.VScroll:SetVisible(false);
	end

	local colWidth1=StatsPanel:GetWidth()/3;
	local colWidth2=StatsPanel:GetWidth()/4;

	StatsPanel.RaceBackground:SetWidth(colWidth2);
	StatsPanel.RaceText:SetWidth(colWidth2-5);
	StatsPanel.Separator1:SetLeft(colWidth2);
	StatsPanel.GenderBackground:SetWidth(colWidth2);
	StatsPanel.GenderBackground:SetLeft(colWidth2+2);
	StatsPanel.GenderRB:SetWidth(colWidth2);
	StatsPanel.Separator5:SetLeft(colWidth2*2);
	StatsPanel.ClassBackground:SetLeft(colWidth2*2+2);
	StatsPanel.ClassBackground:SetWidth(colWidth2);
	StatsPanel.ClassText:SetSize(colWidth2-5,18);
	StatsPanel.Separator2:SetLeft(colWidth2*3);
	StatsPanel.LevelBackground:SetLeft(colWidth2*3+2);
	StatsPanel.LevelBackground:SetWidth(colWidth2);
	StatsPanel.LevelText:SetSize(colWidth2-5,18);


	StatsPanel.MoraleBackground:SetWidth(colWidth1);
	StatsPanel.MoraleValue:SetWidth(colWidth1-88);
	StatsPanel.Separator3:SetLeft(colWidth1);
	StatsPanel.PowerBackground:SetWidth(colWidth1);
	StatsPanel.PowerBackground:SetLeft(colWidth1+2);
	StatsPanel.PowerValue:SetWidth(colWidth1-68);
	StatsPanel.Separator4:SetLeft(colWidth1*2);
	StatsPanel.ArmorBackground:SetWidth(colWidth1);
	StatsPanel.ArmorBackground:SetLeft(colWidth1*2+2);
	StatsPanel.ArmorValue:SetWidth(colWidth1-78);

	colWidth1=StatsPanel.AP:GetWidth()/2;
	colWidth2=StatsPanel.AP:GetWidth()/2-102;
	local colWidth3=StatsPanel.AP:GetWidth()/2+102;

	StatsPanel.StatsHeading:SetWidth(colWidth1-10);
	StatsPanel.StatsSeparator:SetWidth(StatsPanel.StatsHeading:GetWidth());
	StatsPanel.MightValue:SetWidth(colWidth2);
	StatsPanel.AgilityValue:SetWidth(colWidth2);
	StatsPanel.VitalityValue:SetWidth(colWidth2);
	StatsPanel.WillValue:SetWidth(colWidth2);
	StatsPanel.FateValue:SetWidth(colWidth2);
	StatsPanel.FinesseValue:SetWidth(colWidth2);
	StatsPanel.HealingHeading:SetWidth(colWidth1-10);
	StatsPanel.HealingSeparator:SetWidth(StatsPanel.HealingHeading:GetWidth());
	StatsPanel.OutgoingValue:SetWidth(colWidth2);
	StatsPanel.IncomingValue:SetWidth(colWidth2);

	StatsPanel.AvoidancesHeading:SetWidth(colWidth1-10);
	StatsPanel.AvoidancesSeparator:SetWidth(StatsPanel.AvoidancesHeading:GetWidth());
	StatsPanel.BlockValue:SetWidth(colWidth2);
	StatsPanel.EvadeValue:SetWidth(colWidth2);
	StatsPanel.ParryValue:SetWidth(colWidth2);

	StatsPanel.ResistancesHeading:SetWidth(colWidth1-10);
	StatsPanel.ResistancesHeading:SetLeft(colWidth1);
	StatsPanel.ResistancesSeparator:SetWidth(StatsPanel.ResistancesHeading:GetWidth());
	StatsPanel.ResistancesSeparator:SetLeft(colWidth1);
	StatsPanel.BaseLabel:SetLeft(colWidth1);
	StatsPanel.BaseValue:SetWidth(colWidth2);
	StatsPanel.BaseValue:SetLeft(colWidth3);
	StatsPanel.MitigationsHeading:SetWidth(colWidth1-10);
	StatsPanel.MitigationsHeading:SetLeft(colWidth1);
	StatsPanel.MitigationsSeparator:SetWidth(StatsPanel.MitigationsHeading:GetWidth());
	StatsPanel.MitigationsSeparator:SetLeft(StatsPanel.MitigationsHeading:GetLeft());
	StatsPanel.CommonLabel:SetLeft(colWidth1);
	StatsPanel.CommonValue:SetWidth(colWidth2);
	StatsPanel.CommonValue:SetLeft(colWidth3);
	StatsPanel.FireLabel:SetLeft(colWidth1);
	StatsPanel.FireValue:SetWidth(colWidth2);
	StatsPanel.FireValue:SetLeft(colWidth3);
	StatsPanel.FrostLabel:SetLeft(colWidth1);
	StatsPanel.FrostValue:SetWidth(colWidth2);
	StatsPanel.FrostValue:SetLeft(colWidth3);
	StatsPanel.ShadowLabel:SetLeft(colWidth1);
	StatsPanel.ShadowValue:SetWidth(colWidth2);
	StatsPanel.ShadowValue:SetLeft(colWidth3);
	StatsPanel.LightningLabel:SetLeft(colWidth1);
	StatsPanel.LightningValue:SetWidth(colWidth2);
	StatsPanel.LightningValue:SetLeft(colWidth3);
	StatsPanel.AcidLabel:SetLeft(colWidth1);
	StatsPanel.AcidValue:SetWidth(colWidth2);
	StatsPanel.AcidValue:SetLeft(colWidth3);
	StatsPanel.PhysicalLabel:SetLeft(colWidth1);
	StatsPanel.PhysicalValue:SetWidth(colWidth2);
	StatsPanel.PhysicalValue:SetLeft(colWidth3);
	StatsPanel.TacticalLabel:SetLeft(colWidth1);
	StatsPanel.TacticalValue:SetWidth(colWidth2);
	StatsPanel.TacticalValue:SetLeft(colWidth3);

	colWidth1=StatsPanel.AP:GetWidth()/3;
	StatsPanel.MeleeHeading:SetWidth(colWidth1);
	StatsPanel.MeleeHeading:SetLeft(colWidth1);
	StatsPanel.MeleeSeparator:SetWidth(StatsPanel.MeleeHeading:GetWidth());
	StatsPanel.MeleeSeparator:SetLeft(StatsPanel.MeleeHeading:GetLeft());
	StatsPanel.TacticalHeading:SetWidth(colWidth1);
	StatsPanel.TacticalHeading:SetLeft(colWidth1*2);
	StatsPanel.TacticalSeparator:SetWidth(StatsPanel.TacticalHeading:GetWidth());
	StatsPanel.TacticalSeparator:SetLeft(StatsPanel.TacticalHeading:GetLeft());

	StatsPanel.CriticalAvoidLabel:SetWidth(colWidth1-1);
	StatsPanel.CriticalMeleeAvoidValue:SetWidth(colWidth1);
	StatsPanel.CriticalMeleeAvoidValue:SetLeft(colWidth1);
	StatsPanel.CriticalTacticalAvoidValue:SetWidth(colWidth1);
	StatsPanel.CriticalTacticalAvoidValue:SetLeft(colWidth1*2);

	StatsPanel.CritHitChanceLabel:SetWidth(colWidth1-1);
	StatsPanel.CritHitMeleeChanceValue:SetWidth(colWidth1);
	StatsPanel.CritHitMeleeChanceValue:SetLeft(colWidth1);
	StatsPanel.CritHitTacticalChanceValue:SetWidth(colWidth1);
	StatsPanel.CritHitTacticalChanceValue:SetLeft(colWidth1*2);

	StatsPanel.DamageLabel:SetWidth(colWidth1-1);
	StatsPanel.DamageMeleeValue:SetWidth(colWidth1);
	StatsPanel.DamageMeleeValue:SetLeft(colWidth1);
	StatsPanel.DamageTacticalValue:SetWidth(colWidth1);
	StatsPanel.DamageTacticalValue:SetLeft(colWidth1*2);
end

StatsPanel.LoadCharData=function()
	StatsPanel.LoadingData=true;

	if (selectedCharName==charName) then
		-- get the current player stats
		StatsPanel.Race=getRaceIndex(localPlayer:GetRace());
		StatsPanel.Class=getClassIndex(localPlayer:GetClass());

		StatsPanel.MoraleValue:SetText(math.floor(localPlayer:GetMorale()+.5).."/"..math.floor(localPlayer:GetMaxMorale()+.5));
		StatsPanel.PowerValue:SetText(math.floor(localPlayer:GetPower()+.5).."/"..math.floor(localPlayer:GetMaxPower()+.5));
		StatsPanel.ArmorValue:SetText(StatsPanel.Attributes:GetArmor().." *");
		StatsPanel.AcidValue:SetText(math.floor(StatsPanel.Attributes:GetAcidMitigation()*100+.5)/100);
		StatsPanel.AgilityValue:SetText(StatsPanel.Attributes:GetAgility());
		StatsPanel.FateValue:SetText(StatsPanel.Attributes:GetFate());
		StatsPanel.BaseValue:SetText(StatsPanel.Attributes:GetBaseResistance());
		StatsPanel.BlockValue:SetText(StatsPanel.Attributes:GetBlock());
		StatsPanel.CommonValue:SetText(math.floor(StatsPanel.Attributes:GetCommonMitigation()*100+.5)/100);
		StatsPanel.EvadeValue:SetText(StatsPanel.Attributes:GetEvade());
		StatsPanel.FinesseValue:SetText(StatsPanel.Attributes:GetFinesse());

		StatsPanel.FireValue:SetText(math.floor(StatsPanel.Attributes:GetFireMitigation()*100+.5)/100);
		StatsPanel.FrostValue:SetText(math.floor(StatsPanel.Attributes:GetFrostMitigation()*100+.5)/100);
		StatsPanel.IncomingValue:SetText(math.floor(StatsPanel.Attributes:GetIncomingHealing()*100+.5)/100);
		StatsPanel.LightningValue:SetText(math.floor(StatsPanel.Attributes:GetLightningMitigation()*100+.5)/100);
		StatsPanel.ParryValue:SetText(StatsPanel.Attributes:GetParry());
		StatsPanel.PhysicalValue:SetText(math.floor(StatsPanel.Attributes:GetPhysicalMitigation()*100+.5)/100);
		StatsPanel.ShadowValue:SetText(math.floor(StatsPanel.Attributes:GetShadowMitigation()*100+.5)/100);
		StatsPanel.TacticalValue:SetText(math.floor(StatsPanel.Attributes:GetTacticalMitigation()*100+.5)/100);

		StatsPanel.OutgoingValue:SetText(math.floor(StatsPanel.Attributes:GetOutgoingHealing()*100+.5)/100);
		StatsPanel.MightValue:SetText(StatsPanel.Attributes:GetMight());
		StatsPanel.VitalityValue:SetText(StatsPanel.Attributes:GetVitality());
		StatsPanel.WillValue:SetText(StatsPanel.Attributes:GetWill());

		StatsPanel.CriticalMeleeAvoidValue:SetText(StatsPanel.Attributes:GetMeleeCriticalHitAvoidance());
		StatsPanel.CriticalTacticalAvoidValue:SetText(StatsPanel.Attributes:GetTacticalCriticalHitAvoidance());
		StatsPanel.CritHitMeleeChanceValue:SetText(StatsPanel.Attributes:GetMeleeCriticalHitChance());
		StatsPanel.CritHitTacticalChanceValue:SetText(StatsPanel.Attributes:GetTacticalCriticalHitChance());

		StatsPanel.DamageMeleeValue:SetText(StatsPanel.Attributes:GetMeleeDamage());
		StatsPanel.DamageTacticalValue:SetText(StatsPanel.Attributes:GetTacticalDamage());

	else
		local tmpStats=charStats[selectedCharName];
		StatsPanel.Race=getRaceIndex(charList[selectedCharName].Race);
		StatsPanel.Class=getClassIndex(charList[selectedCharName].Class);
		if tmpStats~=nil then
			if tmpStats.Morale~=nil then
				StatsPanel.MoraleValue:SetText(math.floor(tmpStats.Morale+.5).."/"..math.floor(tmpStats.Morale+.5));
			else
				StatsPanel.MoraleValue:SetText("0/0");
			end
			if tmpStats.Power~=nil then
				StatsPanel.PowerValue:SetText(math.floor(tmpStats.Power+.5).."/"..math.floor(tmpStats.Power+.5));
			else
				StatsPanel.PowerValue:SetText("0/0");
			end
			if tmpStats.AcidMitigation~=nil then
				StatsPanel.AcidValue:SetText(math.floor(tmpStats.AcidMitigation*100+.5)/100);
			else
				StatsPanel.AcidValue:SetText("0");
			end
			if tmpStats.Agility~=nil then
				StatsPanel.AgilityValue:SetText(tmpStats.Agility);
			else
				StatsPanel.AgilityValue:SetText("0");
			end
			if tmpStats.Armor~=nil then
				StatsPanel.ArmorValue:SetText(tmpStats.Armor);
			else
				StatsPanel.ArmorValue:SetText("0");
			end
			if tmpStats.BaseResistance~=nil then
				StatsPanel.BaseValue:SetText(tmpStats.BaseResistance);
			else
				StatsPanel.BaseValue:SetText("0");
			end
			if tmpStats.Block~=nil then
				StatsPanel.BlockValue:SetText(tmpStats.Block);
			else
				StatsPanel.BlockValue:SetText("0");
			end
			if tmpStats.CommonMitigation~=nil then
				StatsPanel.CommonValue:SetText(math.floor(tmpStats.CommonMitigation*100+.5)/100);
			else
				StatsPanel.CommonValue:SetText("0");
			end
			if tmpStats.Evade~=nil then
				StatsPanel.EvadeValue:SetText(tmpStats.Evade);
			else
				StatsPanel.EvadeValue:SetText("0");
			end
			if tmpStats.Fate~=nil then
				StatsPanel.FateValue:SetText(tmpStats.Fate);
			else
				StatsPanel.FateValue:SetText("0");
			end
			if tmpStats.Finesse~=nil then
				StatsPanel.FinesseValue:SetText(tmpStats.Finesse);
			else
				StatsPanel.FinesseValue:SetText(0);
			end
			if tmpStats.FireMitigation~=nil then
				StatsPanel.FireValue:SetText(math.floor(tmpStats.FireMitigation*100+.5)/100);
			else
				StatsPanel.FireValue:SetText(0);
			end
			if tmpStats.FrostMitigation~=nil then
				StatsPanel.FrostValue:SetText(math.floor(tmpStats.FrostMitigation*100+.5)/100);
			else
				StatsPanel.FrostValue:SetText(0);
			end
			if tmpStats.IncomingHealing~=nil then
				StatsPanel.IncomingValue:SetText(math.floor(tmpStats.IncomingHealing*100+.5)/100);
			else
				StatsPanel.IncomingValue:SetText(0);
			end
			if tmpStats.LightningMitigation~=nil then
				StatsPanel.LightningValue:SetText(math.floor(tmpStats.LightningMitigation*100+.5)/100);
			else
				StatsPanel.LightningValue:SetText(0);
			end
			if tmpStats.MeleeCriticalHitAvoidance~=nil then
				StatsPanel.CriticalMeleeAvoidValue:SetText(tmpStats.MeleeCriticalHitAvoidance);
			else
				StatsPanel.CriticalMeleeAvoidValue:SetText("0");
			end
			if tmpStats.MeleeCriticalHitChance~=nil then
				StatsPanel.CritHitMeleeChanceValue:SetText(tmpStats.MeleeCriticalHitChance);
			else
				StatsPanel.CritHitMeleeChanceValue:SetText("0");
			end
			if tmpStats.MeleeDamage~=nil then
				StatsPanel.DamageMeleeValue:SetText(tmpStats.MeleeDamage);
			else
				StatsPanel.DamageMeleeValue:SetText("0");
			end
			if tmpStats.Might~=nil then
				StatsPanel.MightValue:SetText(tmpStats.Might);
			else
				StatsPanel.MightValue:SetText("0");
			end
			if tmpStats.OutgoingHealing~=nil then
				StatsPanel.OutgoingValue:SetText(math.floor(tmpStats.OutgoingHealing*100+.5)/100);
			else
				StatsPanel.OutgoingValue:SetText(0);
			end
			if tmpStats.Parry~=nil then
				StatsPanel.ParryValue:SetText(tmpStats.Parry);
			else
				StatsPanel.ParryValue:SetText(0);
			end
			if tmpStats.PhysicalMitigation~=nil then
				StatsPanel.PhysicalValue:SetText(math.floor(tmpStats.PhysicalMitigation*100+.5)/100);
			else
				StatsPanel.PhysicalValue:SetText(0);
			end
			if tmpStats.ShadowMitigation~=nil then
				StatsPanel.ShadowValue:SetText(math.floor(tmpStats.ShadowMitigation*100+.5)/100);
			else
				StatsPanel.ShadowValue:SetText(0);
			end
			if tmpStats.TacticalCriticalHitAvoidance~=nil then
				StatsPanel.CriticalTacticalAvoidValue:SetText(tmpStats.TacticalCriticalHitAvoidance);
			else
				StatsPanel.CriticalTacticalAvoidValue:SetText("0");
			end
			if tmpStats.TacticalCriticalHitChance~=nil then
				StatsPanel.CritHitTacticalChanceValue:SetText(tmpStats.TacticalCriticalHitChance);
			else
				StatsPanel.CritHitTacticalChanceValue:SetText("0");
			end
			if tmpStats.TacticalDamage~=nil then
				StatsPanel.DamageTacticalValue:SetText(tmpStats.TacticalDamage);
			else
				StatsPanel.DamageTacticalValue:SetText("0");
			end
			if tmpStats.TacticalMitigation~=nil then
				StatsPanel.TacticalValue:SetText(math.floor(tmpStats.TacticalMitigation*100+.5)/100);
			else
				StatsPanel.TacticalValue:SetText("0");
			end
			if tmpStats.Vitality~=nil then
				StatsPanel.VitalityValue:SetText(tmpStats.Vitality);
			else
				StatsPanel.VitalityValue:SetText("0");
			end
			if tmpStats.Will~=nil then
				StatsPanel.WillValue:SetText(tmpStats.Will);
			else
				StatsPanel.WillValue:SetText("0");
			end
		end
	end

	--set the array text fields
	if charList[selectedCharName].Race~=nil then
		StatsPanel.RaceText:SetText(raceArray[getRaceIndex(charList[selectedCharName].Race)][2]);
	end
	if charList[selectedCharName].Class~=nil then
		StatsPanel.ClassText:SetText(classArray[getClassIndex(charList[selectedCharName].Class)][3]);
	end
	StatsPanel.LevelText:SetText(Resource[language][40].." "..charList[selectedCharName].Level);

	if charList[selectedCharName].Gender=="F" then
		StatsPanel.GenderRB:SetSelectedChoice(2);
	else
		StatsPanel.GenderRB:SetSelectedChoice(1);
	end
	StatsPanel.LoadingData=false;
end

StatsPanel.SetColors=function()
	StatsPanel:SetBackColor(settings.BackColor);
	StatsPanel.VP:SetBackColor(settings.BackColor);
	StatsPanel.AP:SetBackColor(settings.BackColor);
	StatsPanel.StatsSeparator:SetBackColor(settings.TrimColor);
	StatsPanel.HealingSeparator:SetBackColor(settings.TrimColor);
	StatsPanel.AvoidancesSeparator:SetBackColor(settings.TrimColor);
	StatsPanel.ResistancesSeparator:SetBackColor(settings.TrimColor);
	StatsPanel.MitigationsSeparator:SetBackColor(settings.TrimColor);
	StatsPanel.MeleeSeparator:SetBackColor(settings.TrimColor);
	StatsPanel.TacticalSeparator:SetBackColor(settings.TrimColor);

	StatsPanel.RaceText:SetForeColor(settings.ForeColor);
	StatsPanel.ClassText:SetForeColor(settings.ForeColor);
	StatsPanel.LevelText:SetForeColor(settings.ForeColor);
	StatsPanel.MightLabel:SetForeColor(settings.ForeColor);
	StatsPanel.AgilityLabel:SetForeColor(settings.ForeColor);
	StatsPanel.VitalityLabel:SetForeColor(settings.ForeColor);
	StatsPanel.WillLabel:SetForeColor(settings.ForeColor);
	StatsPanel.FateLabel:SetForeColor(settings.ForeColor);
	StatsPanel.OutgoingLabel:SetForeColor(settings.ForeColor);
	StatsPanel.IncomingLabel:SetForeColor(settings.ForeColor);
	StatsPanel.BlockLabel:SetForeColor(settings.ForeColor);
	StatsPanel.EvadeLabel:SetForeColor(settings.ForeColor);
	StatsPanel.ParryLabel:SetForeColor(settings.ForeColor);

	StatsPanel.CommonLabel:SetForeColor(settings.ForeColor);
	StatsPanel.FireLabel:SetForeColor(settings.ForeColor);
	StatsPanel.FrostLabel:SetForeColor(settings.ForeColor);
	StatsPanel.ShadowLabel:SetForeColor(settings.ForeColor);
	StatsPanel.LightningLabel:SetForeColor(settings.ForeColor);
	StatsPanel.AcidLabel:SetForeColor(settings.ForeColor);
	StatsPanel.TacticalLabel:SetForeColor(settings.ForeColor);
	StatsPanel.CriticalAvoidLabel:SetForeColor(settings.ForeColor);
	StatsPanel.CritHitChanceLabel:SetForeColor(settings.ForeColor);
	StatsPanel.DamageLabel:SetForeColor(settings.ForeColor);
	StatsPanel.FinesseLabel:SetForeColor(settings.ForeColor);
	StatsPanel.BaseLabel:SetForeColor(settings.ForeColor);
	StatsPanel.PhysicalLabel:SetForeColor(settings.ForeColor);

	StatsPanel.StatsHeading:SetForeColor(settings.HeadingsColor);
	StatsPanel.HealingHeading:SetForeColor(settings.HeadingsColor);
	StatsPanel.AvoidancesHeading:SetForeColor(settings.HeadingsColor);
	StatsPanel.ResistancesHeading:SetForeColor(settings.HeadingsColor);
	StatsPanel.MitigationsHeading:SetForeColor(settings.HeadingsColor);
	StatsPanel.MeleeHeading:SetForeColor(settings.HeadingsColor);
	StatsPanel.TacticalHeading:SetForeColor(settings.HeadingsColor);
end
StatsPanel.SetLanguage=function()
	classArray={{0,3,Resource[language][82]},{194,3,Resource[language][90]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][98]},{Turbine.Gameplay.Class.BlackArrow,2,Resource[language][93]},{Turbine.Gameplay.Class.Burglar,1,Resource[language][89]},{Turbine.Gameplay.Class.Captain,1,Resource[language][83]},{Turbine.Gameplay.Class.Champion,1,Resource[language][84]},{Turbine.Gameplay.Class.Chicken,3,Resource[language][98]},{Turbine.Gameplay.Class.Defiler,2,Resource[language][97]},{Turbine.Gameplay.Class.Guardian,1,Resource[language][85]},{Turbine.Gameplay.Class.Hunter,1,Resource[language][87]},{Turbine.Gameplay.Class.LoreMaster,1,Resource[language][88]},{Turbine.Gameplay.Class.Minstrel,1,Resource[language][86]},{Turbine.Gameplay.Class.Ranger,1,Resource[language][100]},{Turbine.Gameplay.Class.Reaver,2,Resource[language][92]},{Turbine.Gameplay.Class.RuneKeeper,1,Resource[language][91]},{Turbine.Gameplay.Class.Stalker,2,Resource[language][95]},{Turbine.Gameplay.Class.WarLeader,2,Resource[language][94]},{Turbine.Gameplay.Class.Weaver,2,Resource[language][96]},{195,3,Resource[language][101]}};
	raceArray={{0,Resource[language][82]},{Turbine.Gameplay.Race.Dwarf,Resource[language][72]},{Turbine.Gameplay.Race.Elf,Resource[language][74]},{Turbine.Gameplay.Race.Hobbit,Resource[language][73]},{Turbine.Gameplay.Race.Man,Resource[language][71]},{66,Resource[language][77]},{7,Resource[language][75]},{12,Resource[language][78]},{6,Resource[language][76]},{27,Resource[language][79]},{74,Resource[language][81]}}
	if StatsPanel.Race~=nil and raceArray[StatsPanel.Race]~=nil then
		StatsPanel.RaceText:SetText(raceArray[StatsPanel.Race][2]);
	end
	if StatsPanel.Class~=nil and classArray[StatsPanel.Class]~=nil then
		StatsPanel.ClassText:SetText(classArray[StatsPanel.Class][3]);
	end
	StatsPanel.LevelText:SetText(Resource[language][40].." "..StatsPanel.Level);
	StatsPanel.MoraleLabel:SetText(Resource[language][41]);
	StatsPanel.PowerLabel:SetText(Resource[language][42]);
	StatsPanel.ArmorLabel:SetText(Resource[language][43]);
	StatsPanel.StatsHeading:SetText(Resource[language][44]);
	StatsPanel.MightLabel:SetText(Resource[language][45]);
	StatsPanel.AgilityLabel:SetText(Resource[language][46]);
	StatsPanel.VitalityLabel:SetText(Resource[language][47]);
	StatsPanel.WillLabel:SetText(Resource[language][48]);
	StatsPanel.FateLabel:SetText(Resource[language][49]);
	StatsPanel.TacticalLabel:SetText(Resource[language][50]);
	StatsPanel.TacticalHeading:SetText(Resource[language][50]);
	StatsPanel.HealingHeading:SetText(Resource[language][51]);
	StatsPanel.OutgoingLabel:SetText(Resource[language][52]);
	StatsPanel.IncomingLabel:SetText(Resource[language][53]);
	StatsPanel.AvoidancesHeading:SetText(Resource[language][54]);
	StatsPanel.BlockLabel:SetText(Resource[language][55]);
	StatsPanel.EvadeLabel:SetText(Resource[language][56]);
	StatsPanel.ParryLabel:SetText(Resource[language][57]);
	StatsPanel.ResistancesHeading:SetText(Resource[language][58]);
	StatsPanel.MitigationsHeading:SetText(Resource[language][59]);
	StatsPanel.CommonLabel:SetText(Resource[language][60]);
	StatsPanel.FireLabel:SetText(Resource[language][61]);
	StatsPanel.FrostLabel:SetText(Resource[language][62]);
	StatsPanel.ShadowLabel:SetText(Resource[language][63]);
	StatsPanel.LightningLabel:SetText(Resource[language][64]);
	StatsPanel.AcidLabel:SetText(Resource[language][65]);
	StatsPanel.CriticalAvoidLabel:SetText(Resource[language][66]);
	StatsPanel.CritHitChanceLabel:SetText(Resource[language][67]);
	StatsPanel.FinesseLabel:SetText(Resource[language][68]);
	StatsPanel.MeleeHeading:SetText(Resource[language][69]);
	StatsPanel.DamageLabel:SetText(Resource[language][70]);
end

StatsPanel.SaveData=function()
	PatchDataSave( Turbine.DataScope.Server, "AltViewer_CharStats",charStats);
end
StatsPanel.RemoveCallbacks=function()
	-- remove all of the attribute callbacks that we set
end
